Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Stack/PushGPStack.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Stack/PushGPStack.cs	(revision 14397)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Stack/PushGPStack.cs	(revision 14398)
@@ -20,14 +20,14 @@
         public PushGPStack(int capacity = 0)
         {
-            this.data = new List<T>();
-        }
-
-        public T Top { get { return this.data[Count - 1]; } }
-        public T TopOrDefault { get { return Count > 0 ? this.data[Count - 1] : default(T); } }
-        public T Bottom { get { return this.data[0]; } }
-        public T BottomOrDefault { get { return Count > 0 ? this.data[0] : default(T); } }
-        public int Count { get { return this.data.Count; } }
-        public int Capacity { get { return this.data.Capacity; } }
-        public bool IsEmpty { get { return this.Count == 0; } }
+            data = new List<T>();
+        }
+
+        public T Top { get { return data[Count - 1]; } }
+        public T TopOrDefault { get { return Count > 0 ? data[Count - 1] : default(T); } }
+        public T Bottom { get { return data[0]; } }
+        public T BottomOrDefault { get { return Count > 0 ? data[0] : default(T); } }
+        public int Count { get { return data.Count; } }
+        public int Capacity { get { return data.Capacity; } }
+        public bool IsEmpty { get { return Count == 0; } }
 
         public bool IsReadOnly { get { return false; } }
@@ -35,30 +35,30 @@
         public void Add(T item)
         {
-            this.Push(item);
+            Push(item);
         }
 
         public void Clear()
         {
-            this.data.Clear();
+            data.Clear();
         }
 
         public bool Contains(T item)
         {
-            return this.data.Contains(item);
+            return data.Contains(item);
         }
 
         public void CopyTo(T[] array, int arrayIndex)
         {
-            this.data.CopyTo(array, arrayIndex);
+            data.CopyTo(array, arrayIndex);
         }
 
         public IEnumerator<T> GetEnumerator()
         {
-            return this.data.GetEnumerator();
+            return data.GetEnumerator();
         }
 
         public T ElementAt(int index)
         {
-            return this.data[index];
+            return data[index];
         }
 
@@ -66,42 +66,42 @@
         public T ReverseElementAt(int offset)
         {
-            return this.data[this.Count - 1 - offset];
+            return data[Count - 1 - offset];
         }
 
         public void SetTop(T value)
         {
-            this.data[Count - 1] = value;
+            data[Count - 1] = value;
         }
 
         public T this[int key]
         {
-            get { return this.data[key]; }
-            set { this.data[key] = value; }
+            get { return data[key]; }
+            set { data[key] = value; }
         }
 
         public void Swap(int count)
         {
-            var top = this.Top;
-            var bottomIndex = this.Count - count;
-
-            for (var i = this.Count - 1; i > bottomIndex; i--)
-            {
-                this.data[i] = this.data[i - 1];
-            }
-
-            this.data[bottomIndex] = top;
+            var top = Top;
+            var bottomIndex = Count - count;
+
+            for (var i = Count - 1; i > bottomIndex; i--)
+            {
+                data[i] = data[i - 1];
+            }
+
+            data[bottomIndex] = top;
         }
 
         public void Yank(int index)
         {
-            var item = this.ElementAt(index);
-            this.data.RemoveAt(index);
-            this.data.Add(item);
+            var item = ElementAt(index);
+            data.RemoveAt(index);
+            data.Add(item);
         }
 
         public T Pop()
         {
-            var value = this.data[Count - 1];
-            this.data.RemoveAt(Count - 1);
+            var value = data[Count - 1];
+            data.RemoveAt(Count - 1);
 
             return value;
@@ -113,6 +113,6 @@
 
             var items = new T[count];
-            this.data.CopyTo(startIndex, items, 0, count);
-            this.Remove(count);
+            data.CopyTo(startIndex, items, 0, count);
+            Remove(count);
 
             return items;
@@ -121,5 +121,5 @@
         public void Push(T item)
         {
-            this.data.Add(item);
+            data.Add(item);
         }
 
@@ -128,5 +128,5 @@
             for (var i = 0; i < items.Length; i++)
             {
-                this.data.Add((T)items[i]);
+                data.Add((T)items[i]);
             }
         }
@@ -137,8 +137,8 @@
             var items = new T[count];
 
-            this.data.CopyTo(startIndex, items, 0, count);
-            this.Remove(count - 1);
-
-            this.data[Count - 1] = templateFunc(items);
+            data.CopyTo(startIndex, items, 0, count);
+            Remove(count - 1);
+
+            data[Count - 1] = templateFunc(items);
         }
 
@@ -147,5 +147,5 @@
             for (var i = 0; i < items.Length; i++)
             {
-                this.data.Add(items[i]);
+                data.Add(items[i]);
             }
         }
@@ -153,20 +153,20 @@
         public void Push(IEnumerable<T> items)
         {
-            this.data.AddRange(items);
+            data.AddRange(items);
         }
 
         public void Insert(int index, T item)
         {
-            this.data.Insert(index, item);
+            data.Insert(index, item);
         }
 
         public void Insert(int index, params T[] items)
         {
-            this.data.InsertRange(index, items);
+            data.InsertRange(index, items);
         }
 
         public void Insert(int index, IEnumerable<T> items)
         {
-            this.data.InsertRange(index, items);
+            data.InsertRange(index, items);
         }
 
@@ -174,7 +174,7 @@
         {
             var index = Count - 1;
-            if (this.Count > 0 && this.data[index].Equals(item))
-            {
-                this.data.RemoveAt(index);
+            if (Count > 0 && data[index].Equals(item))
+            {
+                data.RemoveAt(index);
                 return true;
             }
@@ -187,5 +187,5 @@
         public void RemoveTop()
         {
-            this.data.RemoveAt(this.Count - 1);
+            data.RemoveAt(Count - 1);
         }
 
@@ -194,5 +194,5 @@
             for (var i = 0; i < count; i++)
             {
-                this.data.RemoveAt(Count - 1);
+                data.RemoveAt(Count - 1);
             }
         }
@@ -200,17 +200,17 @@
         public void RemoveAt(int index)
         {
-            this.data.RemoveAt(index);
+            data.RemoveAt(index);
         }
 
         public void RemoveAt(int index, int count)
         {
-            this.data.RemoveRange(index, count);
+            data.RemoveRange(index, count);
         }
 
         public bool TryPop(out T item)
         {
-            if (this.Count > 0)
-            {
-                item = this.Pop();
+            if (Count > 0)
+            {
+                item = Pop();
                 return true;
             }
@@ -224,10 +224,10 @@
         IEnumerator IEnumerable.GetEnumerator()
         {
-            return (this.data as IEnumerable).GetEnumerator();
+            return (data as IEnumerable).GetEnumerator();
         }
 
         public override string ToString()
         {
-            return string.Join(Delimiter, this.data);
+            return string.Join(Delimiter, data);
         }
     }
Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/CountOdds.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/CountOdds.cs	(revision 14397)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/CountOdds.cs	(revision 14398)
@@ -31,14 +31,14 @@
         protected override IEnumerable<List<int>> GenerateTest()
         {
-            foreach (var list in this.GetHardcodedTrainingSamples())
+            foreach (var list in GetHardcodedTrainingSamples())
                 yield return list;
 
-            foreach (var list in this.GetAllOdd(n: 100))
+            foreach (var list in GetAllOdd(n: 100))
                 yield return list;
 
-            foreach (var list in this.GetAllEven(n: 100))
+            foreach (var list in GetAllEven(n: 100))
                 yield return list;
 
-            foreach (var list in this.GetRandom(n: 1800))
+            foreach (var list in GetRandom(n: 1800))
                 yield return list;
         }
@@ -46,14 +46,14 @@
         protected override IEnumerable<List<int>> GenerateTraining()
         {
-            foreach (var list in this.GetHardcodedTrainingSamples())
+            foreach (var list in GetHardcodedTrainingSamples())
                 yield return list;
 
-            foreach (var list in this.GetAllOdd(n: 9))
+            foreach (var list in GetAllOdd(n: 9))
                 yield return list;
 
-            foreach (var list in this.GetAllEven(n: 9))
+            foreach (var list in GetAllEven(n: 9))
                 yield return list;
 
-            foreach (var list in this.GetRandom(n: 150))
+            foreach (var list in GetRandom(n: 150))
                 yield return list;
         }
Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Benchmark/ExampleConverter.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Benchmark/ExampleConverter.cs	(revision 14397)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Benchmark/ExampleConverter.cs	(revision 14398)
@@ -1,4 +1,3 @@
-﻿using System;
-using System.Linq;
+﻿using System.Linq;
 
 namespace HeuristicLab.Tests.Benchmark
@@ -10,13 +9,11 @@
         private static readonly char[] arraySymbolTrim = new[] { '[', ']' };
 
-        public static Converter<string, long> Integer = new Converter<string, long>(GetInteger);
-        public static Converter<string, long[]> Integers = new Converter<string, long[]>(GetIntegers);
 
-        public static long GetInteger(string str)
+        public static long Integer(string str)
         {
             return long.Parse(str);
         }
 
-        public static long[] GetIntegers(string str)
+        public static long[] Integers(string str)
         {
             var values = str
@@ -30,5 +27,5 @@
             for (var i = 0; i < result.Length; i++)
             {
-                result[i] = GetInteger(values[i]);
+                result[i] = Integer(values[i]);
             }
 
Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Benchmark/Problem/CountOdds.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Benchmark/Problem/CountOdds.cs	(revision 14397)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Benchmark/Problem/CountOdds.cs	(revision 14398)
@@ -17,11 +17,13 @@
         public CountOdds()
         {
-            this.Examples = this.GetExamples(ProblemFileName, ExampleConverter.Integers, ExampleConverter.Integer);
+            Examples = GetExamples(ProblemFileName, ExampleConverter.Integers, ExampleConverter.Integer);
         }
 
         [TestMethod]
+        [TestProperty("Time", "Medium")]
+        [TestCategory("ProblemTest")]
         public void RandomWalk()
         {
-            var limit = 1000;
+            var maxProgramSizeLimit = 1000;
             var iterations = 20000;
             var best = double.MaxValue;
@@ -39,8 +41,8 @@
 
                 var execCounter = 0;
-                var program = interpreter.CodeGenerator.RandomProgram(limit);
+                var program = interpreter.CodeGenerator.RandomProgram(maxProgramSizeLimit);
                 var results = new List<long>();
 
-                foreach (var example in this.Examples)
+                foreach (var example in Examples)
                 {
                     if (example.Input.Length > 0)
Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/BooleanExpressionTests.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/BooleanExpressionTests.cs	(revision 14397)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/BooleanExpressionTests.cs	(revision 14398)
@@ -12,4 +12,7 @@
 
         [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("BooleanExpressionTest")]
         public void TestAnd()
         {
@@ -19,14 +22,20 @@
             Assert.AreEqual(false, interpreter.BooleanStack.Top);
 
-            this.TestStackCounts(booleanStack: 1);
+            TestStackCounts(booleanStack: 1);
         }
 
         [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("BooleanExpressionTest")]
         public void TestAndWithInsufficientArguments()
         {
-            this.TestWithInsufficientArguments("AND", 1);
+            TestWithInsufficientArguments("AND", 1);
         }
 
         [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("BooleanExpressionTest")]
         public void TestOr()
         {
@@ -36,14 +45,20 @@
             Assert.AreEqual(true, interpreter.BooleanStack.Top);
 
-            this.TestStackCounts(booleanStack: 1);
+            TestStackCounts(booleanStack: 1);
         }
 
         [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("BooleanExpressionTest")]
         public void TestOrWithInsufficientArguments()
         {
-            this.TestWithInsufficientArguments("OR", 1);
+            TestWithInsufficientArguments("OR", 1);
         }
 
         [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("BooleanExpressionTest")]
         public void TestNot()
         {
@@ -53,14 +68,20 @@
             Assert.AreEqual(false, interpreter.BooleanStack.Top);
 
-            this.TestStackCounts(booleanStack: 1);
+            TestStackCounts(booleanStack: 1);
         }
 
         [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("BooleanExpressionTest")]
         public void TestNotWithInsufficientArguments()
         {
-            this.TestWithInsufficientArguments("NOT");
+            TestWithInsufficientArguments("NOT");
         }
 
         [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("BooleanExpressionTest")]
         public void TestFromFloat()
         {
@@ -70,14 +91,20 @@
             Assert.AreEqual(true, interpreter.BooleanStack.Top);
 
-            this.TestStackCounts(booleanStack: 1);
+            TestStackCounts(booleanStack: 1);
         }
 
         [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("BooleanExpressionTest")]
         public void TestFromFloatWithInsufficientArguments()
         {
-            this.TestWithInsufficientArguments("FROMFLOAT");
+            TestWithInsufficientArguments("FROMFLOAT");
         }
 
         [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("BooleanExpressionTest")]
         public void TestFromInteger()
         {
@@ -87,11 +114,14 @@
             Assert.AreEqual(true, interpreter.BooleanStack.Top);
 
-            this.TestStackCounts(booleanStack: 1);
+            TestStackCounts(booleanStack: 1);
         }
 
         [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("BooleanExpressionTest")]
         public void TestFromIntegerWithInsufficientArguments()
         {
-            this.TestWithInsufficientArguments("FROMINTEGER");
+            TestWithInsufficientArguments("FROMINTEGER");
         }
 
@@ -110,5 +140,5 @@
         protected override void CheckOtherStacksAreEmpty()
         {
-            this.TestStackCounts(booleanStack: null);
+            TestStackCounts(booleanStack: null);
         }
     }
